# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import V2MobiusRulesTopicAddressableEntityRef

class V2MobiusRulesTopicEntityProperties(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        V2MobiusRulesTopicEntityProperties - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'entity_type': 'str',
            'user': 'V2MobiusRulesTopicAddressableEntityRef',
            'group': 'V2MobiusRulesTopicAddressableEntityRef',
            'queue': 'V2MobiusRulesTopicAddressableEntityRef',
            'team': 'V2MobiusRulesTopicAddressableEntityRef'
        }

        self.attribute_map = {
            'entity_type': 'entityType',
            'user': 'user',
            'group': 'group',
            'queue': 'queue',
            'team': 'team'
        }

        self._entity_type = None
        self._user = None
        self._group = None
        self._queue = None
        self._team = None

    @property
    def entity_type(self) -> str:
        """
        Gets the entity_type of this V2MobiusRulesTopicEntityProperties.


        :return: The entity_type of this V2MobiusRulesTopicEntityProperties.
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type: str) -> None:
        """
        Sets the entity_type of this V2MobiusRulesTopicEntityProperties.


        :param entity_type: The entity_type of this V2MobiusRulesTopicEntityProperties.
        :type: str
        """
        if isinstance(entity_type, int):
            entity_type = str(entity_type)
        allowed_values = ["Organization", "User", "Queue", "Group", "Edge", "Team", "TeamMembers"]
        if entity_type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for entity_type -> " + entity_type)
            self._entity_type = "outdated_sdk_version"
        else:
            self._entity_type = entity_type

    @property
    def user(self) -> 'V2MobiusRulesTopicAddressableEntityRef':
        """
        Gets the user of this V2MobiusRulesTopicEntityProperties.


        :return: The user of this V2MobiusRulesTopicEntityProperties.
        :rtype: V2MobiusRulesTopicAddressableEntityRef
        """
        return self._user

    @user.setter
    def user(self, user: 'V2MobiusRulesTopicAddressableEntityRef') -> None:
        """
        Sets the user of this V2MobiusRulesTopicEntityProperties.


        :param user: The user of this V2MobiusRulesTopicEntityProperties.
        :type: V2MobiusRulesTopicAddressableEntityRef
        """
        

        self._user = user

    @property
    def group(self) -> 'V2MobiusRulesTopicAddressableEntityRef':
        """
        Gets the group of this V2MobiusRulesTopicEntityProperties.


        :return: The group of this V2MobiusRulesTopicEntityProperties.
        :rtype: V2MobiusRulesTopicAddressableEntityRef
        """
        return self._group

    @group.setter
    def group(self, group: 'V2MobiusRulesTopicAddressableEntityRef') -> None:
        """
        Sets the group of this V2MobiusRulesTopicEntityProperties.


        :param group: The group of this V2MobiusRulesTopicEntityProperties.
        :type: V2MobiusRulesTopicAddressableEntityRef
        """
        

        self._group = group

    @property
    def queue(self) -> 'V2MobiusRulesTopicAddressableEntityRef':
        """
        Gets the queue of this V2MobiusRulesTopicEntityProperties.


        :return: The queue of this V2MobiusRulesTopicEntityProperties.
        :rtype: V2MobiusRulesTopicAddressableEntityRef
        """
        return self._queue

    @queue.setter
    def queue(self, queue: 'V2MobiusRulesTopicAddressableEntityRef') -> None:
        """
        Sets the queue of this V2MobiusRulesTopicEntityProperties.


        :param queue: The queue of this V2MobiusRulesTopicEntityProperties.
        :type: V2MobiusRulesTopicAddressableEntityRef
        """
        

        self._queue = queue

    @property
    def team(self) -> 'V2MobiusRulesTopicAddressableEntityRef':
        """
        Gets the team of this V2MobiusRulesTopicEntityProperties.


        :return: The team of this V2MobiusRulesTopicEntityProperties.
        :rtype: V2MobiusRulesTopicAddressableEntityRef
        """
        return self._team

    @team.setter
    def team(self, team: 'V2MobiusRulesTopicAddressableEntityRef') -> None:
        """
        Sets the team of this V2MobiusRulesTopicEntityProperties.


        :param team: The team of this V2MobiusRulesTopicEntityProperties.
        :type: V2MobiusRulesTopicAddressableEntityRef
        """
        

        self._team = team

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

